// Tempest jQuery Templating Plugin                                                                                                                          
// ================================                                                                                                                          
//                                                                                                                                                           
// Copyright (c) 2009 Nick Fitzgerald - http://fitzgeraldnick.com/                                                                                           
//                                                                                                                                                           
// Permission is hereby granted, free of charge, to any person obtaining a copy                                                                              
// of this software and associated documentation files (the "Software"), to deal                                                                             
// in the Software without restriction, including without limitation the rights                                                                              
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell                                                                                 
// copies of the Software, and to permit persons to whom the Software is                                                                                     
// furnished to do so, subject to the following conditions:                                                                                                  
//                                                                                                                                                           
// The above copyright notice and this permission notice shall be included in                                                                                
// all copies or substantial portions of the Software.                                                                                                       
//                                                                                                                                                           
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR                                                                                
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,                                                                                  
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE                                                                               
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER                                                                                    
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,                                                                             
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN                                                                                 
// THE SOFTWARE.   
"use strict";(function($){var templateCache={},OPEN_VAR_TAG=/\{\{[\s]*?/g,CLOSE_VAR_TAG=/[\s]*?\}\}/g,OPEN_BLOCK_TAG=/\{%[\s]*?/g,CLOSE_BLOCK_TAG=/[\s]*?%\}/g,VAR_TAG=new RegExp(OPEN_VAR_TAG.source+"[\\w\\-\\.]+?"+
CLOSE_VAR_TAG.source,"g"),BLOCK_TAG=new RegExp(OPEN_BLOCK_TAG.source+"[\\w]+?(?:[ ]+?[\\w\\-\\.]*?)*?"+
CLOSE_BLOCK_TAG.source,"g"),END_BLOCK_TAG=new RegExp(OPEN_BLOCK_TAG.source+"end[\\w]*?"+
CLOSE_BLOCK_TAG.source,"g"),BLOCK_NODES={"if":{expectsEndTag:true,render:function(context){var rendered_nodes=[],subNodes=this.subNodes;if(!!context[this.args[0]]){$.each(subNodes,function(i,node){rendered_nodes.push(node.render(context));});}
return rendered_nodes.join("");}}},baseTextNode={render:function(context){return this.text||"";}},baseVarNode={render:function(context){var val=context[this.name]===undefined?"":context[this.name];if(val===""&&this.name.search(/\./)!==-1){return getValFromObj(this.name,context);}
return cleanVal(val);}};function TemplateSyntaxError(message){if(!(this instanceof TemplateSyntaxError)){return new TemplateSyntaxError(message);}
this.message=message;return this;}
TemplateSyntaxError.prototype=new SyntaxError();TemplateSyntaxError.prototype.name="TemplateSyntaxError";function isBlockTag(token){return token.search(BLOCK_TAG)!==-1;}
function isEndTag(token){return token.search(END_BLOCK_TAG)!==-1;}
function isVarTag(token){return token.search(VAR_TAG)!==-1;}
function strip(str){return str.replace(/^[\s]+/,"").replace(/[\s]+$/,"");}
function cleanVal(val){if(val instanceof $){return jQueryToString(val);}else if(!isArray(val)&&typeof(val)==="object"){if(typeof(val.toHTML)==="function"){return cleanVal(val.toHTML());}else{return val.toString();}}else{return val;}}
function getValFromObj(str,obj){var path=str.split("."),val=obj[path[0]],i;for(i=1;i<path.length;i++){if(val!==undefined){val=val[path[i]];}else{return"";}}
val=val===undefined?"":val;return cleanVal(val);}
function jQueryToString(jq){return $(document.createElement("div")).append(jq).html();}
function makeObj(obj){if(obj===undefined){return obj;}
var O=function(){};O.prototype=obj;return new O();}
function storedTemplates(){var cache=[];$.each(templateCache,function(key,templ){cache.push([key,templ]);});return cache;}
function chooseTemplate(str){return typeof templateCache[str]==="string"?templateCache[str]:str;}
function isArray(objToTest){return Object.prototype.toString.apply(objToTest)==="[object Array]";}
function renderEach(data,f){return isArray(data)?$.each(data,f):f(0,data);}
function tokenize(templ){return(function(arr){var tokens=[];for(i=0;i<arr.length;i++){(function(token){return token===""?null:tokens.push(token);}(arr[i]));}
return tokens;}(templ.split(new RegExp("("+VAR_TAG.source+"|"+
BLOCK_TAG.source+"|"+
END_BLOCK_TAG.source+")"))));}
function cdr(arr){return arr.slice(1);}
function append(item,list){return list.concat([item]);}
function makeVarNode(token){var node=makeObj(baseVarNode);node.name=strip(token.replace(OPEN_VAR_TAG,"").replace(CLOSE_VAR_TAG,""));return node;}
function makeTextNode(token){var node=makeObj(baseTextNode);node.text=token;return node;}
function makeNodes(tokens){return(function(nodes,tokens){var token=tokens[0];return tokens.length===0?[nodes,[],true]:isEndTag(token)?[nodes,cdr(tokens)]:isVarTag(token)?arguments.callee(append(makeVarNode(token),nodes),cdr(tokens)):isBlockTag(token)?makeBlockNode(nodes,tokens,arguments.callee):arguments.callee(append(makeTextNode(token),nodes),cdr(tokens));}([],tokens));}
function makeBits(blockToken){return(function(bits,split){for(i=0;i<split.length;i++){(function(bit){return bit===""?null:bits.push(bit);}(strip(split[i])));}
return bits;}([],blockToken.replace(OPEN_BLOCK_TAG,"").replace(CLOSE_BLOCK_TAG,"").split(/[\s]+?/)));}
function makeBlockNode(nodes,tokens,f){var bits=makeBits(tokens[0]),type=bits[0],args=cdr(bits),node=makeObj(BLOCK_NODES[type]),resultsArray;if(node===undefined){throw new TemplateSyntaxError("Unknown Block Tag.");}
node.args=args;tokens=cdr(tokens);if(node.expectsEndTag===true){resultsArray=makeNodes(tokens);if(resultsArray[2]!==undefined){throw new TemplateSyntaxError("A block tag was expecting an ending tag but it was not found.");}
node.subNodes=resultsArray[0];tokens=resultsArray[1];}
nodes=append(node,nodes);return f(nodes,tokens);}
function renderToJQ(str,objects){var template=chooseTemplate(str),lines=[];renderEach(objects,function(i,obj){var resultsArray=makeNodes(tokenize(template),obj),nodes=resultsArray[0];if(resultsArray[1].length!==0){throw new TemplateSyntaxError("An unexpected end tag was found.");}
$.each(nodes,function(i,node){lines.push(node.render(obj));});});return(function(str){return str.charAt(0)==="<"?$(str):str;}(lines.join("")));}
$.extend({tempest:function(){var args=arguments;if(args.length===0){return storedTemplates();}else if(args.length===2&&typeof(args[0])==="string"&&typeof(args[1])==="object"){return renderToJQ(args[0],args[1]);}else if(args.length===1&&typeof(args[0])==="string"){return templateCache[args[0]];}else if(args.length===2&&typeof(args[0])==="string"&&typeof(args[1])==="string"){templateCache[args[0]]=args[1].replace(/^\s+/g,"").replace(/\s+$/g,"").replace(/[\n\r]+/g,"");return templateCache[args[0]];}else{throw new TypeError("jQuery.tempest can't handle the given arguments.");}}});$.tempest.tags=BLOCK_NODES;if(window.testTempestPrivates===true){$.tempest._test={};function a(name,fn){$.tempest._test[name]=fn;}
a("isBlockTag",isBlockTag);a("isEndTag",isEndTag);a("isVarTag",isVarTag);a("cleanVal",cleanVal);a("getValFromObj",getValFromObj);a("jQueryToString",jQueryToString);a("makeObj",makeObj);a("storedTemplates",storedTemplates);a("chooseTemplate",chooseTemplate);a("isArray",isArray);a("renderEach",renderEach);a("tokenize",tokenize);a("cdr",cdr);a("append",append);a("makeVarNode",makeVarNode);a("makeTextNode",makeTextNode);a("makeNodes",makeNodes);a("makeBits",makeBits);a("makeBlockNode",makeBlockNode);a("renderToJQ",renderToJQ);a("strip",strip);}
$(document).ready(function(){$(".tempest-template").each(function(obj){templateCache[$(this).attr('title')]=strip(($(this).val()||$(this).html()).replace(/[\n\r]+/g," "));$(this).remove();});});}(jQuery));
